//
//  SendMailKitMessage.h
//  SendMailKit
//
//  Created by Stefan on 20.02.13.
//  Copyright (c) 2013 Media Atelier. All rights reserved.
//

#import <Foundation/Foundation.h>

@protocol SendMailKitMessageDelegate;

@interface SendMailKitMessage : NSObject

@property (strong,nonatomic) NSString * recipient;
@property (strong,nonatomic) NSArray * recipients;
@property (strong,nonatomic) NSArray * toRecipients;
@property (strong,nonatomic) NSArray * bccRecipients;
@property (strong,nonatomic) NSArray * ccRecipients;
@property (strong,nonatomic) NSString * subject;
@property (strong,nonatomic) NSString * body;
@property (strong,nonatomic) NSArray * attachments;
@property (strong,nonatomic) NSString * sender;
@property (strong,nonatomic) NSDictionary * metaData;
@property (nonatomic,unsafe_unretained) id <SendMailKitMessageDelegate> delegate;

-(BOOL)compose;


@end


@protocol SendMailKitMessageDelegate <NSObject>
@optional
-(void)sendMailKitMessage:(SendMailKitMessage *)message didFailWithError:(NSDictionary *)error;
@end
